#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ll long long
#define double long double

struct vec{
    int x, y;

    double cross(vec a){
        return x * a.x + y * a.y;
    }

    double dot(vec a){
        return x * a.y - y * a.x;
    }

    int dist(){
        return x * x + y * y;
    }

    double alpha(vec a){
        return abs(atan2l(dot(a), cross(a)));
    }
};

struct point{
    int x, y;
};

struct tri{
    //int x1, y1, x2, y2, x3, y3;
    vector <vec> w;
};

bool equal(double x, double y){
    return (abs(x - y) <= 1e-6);
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    vec ghg = {1, 0};
    vec hah = {-1, 0};
    double pi = ghg.alpha(hah);

    int T;
    cin >> T;

    int n;
    cin >> n;

    if(T == 3){
        vector < vector <int> > otv;

        for(int i1 = 0; i1 < n; ++i1) {
            for (int j1 = i1 + 1; j1 < n; ++j1) {
                for (int k1 = j1 + 1; k1 < n; ++k1) {
                    for (int t1 = k1 + 1; t1 < n; ++t1) {
                        otv.push_back({i1, j1, k1, t1});
                    }
                }
            }
        }

        cout << otv.size() << '\n';
        for(auto & i : otv){
            for(auto j : i){
                cout << j + 1 << " ";
            }
            cout << '\n';
        }

        return 0;
    }

    vector <tri> a(n);
    for(int i = 0; i < n; ++i){
        //cin >> a[i].x1 >> a[i].y1 >> a[i].x2 >> a[i].y2 >> a[i].x3 >> a[i].y3;
        int x1, y1, x2, y2, x3, y3;
        cin >> x1 >> y1 >> x2 >> y2 >> x3 >> y3;

        a[i].w.resize(3, {0, 0});
        a[i].w[0] = {x2 - x1, y2 - y1};
        a[i].w[1] = {x3 - x2, y3 - y2};
        a[i].w[2] = {x1 - x3, y1 - y3};
    }

    vector < vector <int> > otv;

    for(int i1 = 0; i1 < n; ++i1){
        for(int j1 = i1 + 1; j1 < n; ++j1){
            for(int k1 = j1 + 1; k1 < n; ++k1){
                for(int t1 = k1 + 1; t1 < n; ++t1){
                    vector <int> op = {i1, j1, k1, t1};
                    vector <int> p = {0, 1, 2, 3};

                    bool ok = 0;
                    int q = 24;

                    while(!ok && q--){
                        int i = op[p[0]];
                        int j = op[p[1]];
                        int k = op[p[2]];
                        int t = op[p[3]];

                        for(int z1 = 0; z1 < 3; ++z1){
                            for(int z2 = 0; z2 < 3; ++z2){
                                for(int z3 = 0; z3 < 3; ++z3){
                                    if(a[i].w[z1].dist() != a[t].w[0].dist()){
                                        break;
                                    }
                                    if(a[j].w[z2].dist() != a[t].w[2].dist()){
                                        break;
                                    }
                                    if(a[k].w[z3].dist() != a[t].w[1].dist()){
                                        break;
                                    }

                                    //cout << "kdd" << '\n';
                                    //cout << a[i].w[z1].alpha(a[i].w[(z1 + 1) % 3]) + a[j].w[z2].alpha(a[j].w[(z2 + 2) % 3]) + a[t].w[0].alpha(a[t].w[2]) << '\n';
                                    if(!equal(a[i].w[z1].alpha(a[i].w[(z1 + 1) % 3]) + a[j].w[z2].alpha(a[j].w[(z2 + 2) % 3]) + a[t].w[0].alpha(a[t].w[2]), pi)){
                                        break;
                                    }

                                    //cout << a[j].w[z2].alpha(a[j].w[(z2 + 1) % 3]) + a[k].w[z3].alpha(a[k].w[(z3 + 2) % 3]) + a[t].w[1].alpha(a[t].w[2]) << '\n';

                                    if(!equal(a[j].w[z2].alpha(a[j].w[(z2 + 1) % 3]) + a[k].w[z3].alpha(a[k].w[(z3 + 2) % 3]) + a[t].w[1].alpha(a[t].w[2]), pi)){
                                        break;
                                    }

                                    if(!equal(a[k].w[z3].alpha(a[k].w[(z3 + 1) % 3]) + a[i].w[z1].alpha(a[i].w[(z1 + 2) % 3]) + a[t].w[0].alpha(a[t].w[1]), pi)){
                                        break;
                                    }

                                    ok = 1;
                                }
                            }
                        }

                        next_permutation(p.begin(), p.end());
                    }

                    if(ok){
                        otv.push_back({i1, j1, k1, t1});
                    }
                }
            }
        }
    }

    cout << otv.size() << '\n';
    for(auto & i : otv){
        for(auto j : i){
            cout << j + 1 << " ";
        }
        cout << '\n';
    }
}


/*
1
4
0 0 6 2 1 2
0 0 5 0 6 3
0 0 3 1 1 3
0 0 6 3 3 6
 */